#include <iostream>

using namespace std;

bool isOk(int X,int Y, int M)
{
    if(X>=0 && X<M && Y>=0 && Y<M)
    {
        return true;
    }
    return false;
}

void zasadParez(int X,int Y, int M, char ** board)
{
    if(isOk(X,Y,M))
    {
        board[Y][X]=111;
    }
    if(isOk(X-1,Y,M))
    {
        board[Y][X-1]=95;
    }
    if(isOk(X+1,Y,M))
    {
        board[Y][X+1]=95;
    }
}

void zasadStrom(int X,int Y, int S, int M, char ** board)
{
    //Spodek
    if(isOk(X,Y,M))
    {
        board[Y][X]=124;
    }
    if(isOk(X-1,Y,M))
    {
        board[Y][X-1]=95;
    }
    if(isOk(X+1,Y,M))
    {
        board[Y][X+1]=95;
    }

    //Telo
    for(int i=0;i<S;i++)
    {
        if(isOk(X,Y+i+1,M))
        {
            board[Y+i+1][X]=124;
        }
        if(isOk(X-1,Y+i+1,M))
        {
            board[Y+i+1][X-1]=47;
        }
        if(isOk(X+1,Y+i+1,M))
        {
            board[Y+i+1][X+1]=92;
        }
    }

    //Vrsek
    if(isOk(X,Y+S+1,M))
    {
        board[Y+S+1][X]=94;
    }


}

int main()
{
    ios::sync_with_stdio(false);
    while(true)
    {
        int M,N;
        cin>>M>>N;
        if(cin.good()==false)
        {
            return 0;
        }

        //Board setup + grass
        char ** board = new char * [M];
        for(int i=0;i<M;i++)
        {
            board[i] = new char [M];
            for(int j=0;j<M;j++)
            {
                board[i][j]=46;
            }
        }

        //Tree depicting
        for(int t=0;t<N;t++)
        {
            int S,X,Y;
            cin>>S>>X>>Y;

            //TODO
            if(S==0)
            {
                zasadParez(X,Y,M,board);
            }
            else
            {
                zasadStrom(X,Y,S,M,board);
            }


        }

        //Output
        for(int i=0;i<M+2;i++)
        {
            cout<<"*";
        }
        cout<<endl;

        for(int i=M-1;i>=0;i--)
        {
            cout<<"*";

            for(int j=0;j<M;j++)
            {
                cout<<board[i][j];
            }

            cout<<"*";
            cout<<endl;
        }


        for(int i=0;i<M+2;i++)
        {
            cout<<"*";
        }
        cout<<endl;
        cout<<endl;


        for(int i=0;i<M;i++)
        {
            delete [] board[i];
        }
        delete [] board;




    }
    return 0;
}
