#include <iostream>
#include <map>

using namespace std;


int N,K;
int result;
int bestResult;
bool muzesOdpojit(map<int,int> & s,int * overal)
{
    //bool resultado = true;

    for(map<int,int>::iterator it = s.begin();it!=s.end();it++)
    {
        //cout<<it->first-1<<" < "<<it->second<<endl;
        if(overal[it->first-1] <= it->second)
        {
            return false;
        }
    }
    return true;
}

void odpoj(map<int,int> & s,int * overal)
{
    for(map<int,int>::iterator it = s.begin();it!=s.end();it++)
    {
        overal[it->first-1]-=it->second;
        result-=it->second;
    }
}

void pridej(map<int,int> & s,int * overal)
{
    for(map<int,int>::iterator it = s.begin();it!=s.end();it++)
    {
        overal[it->first-1]+=it->second;
        result+=it->second;
    }
}


int main()
{
    ios::sync_with_stdio(false);

    while(true)
    {
        cin>>N>>K;
        result=0;
        if(cin.good()==false)
        {
            return 0;
        }

        //Nacitani stanku
        map<int,int> * stanky = new map<int,int> [N];
        int * overal = new int [K];
        for(int i=0;i<K;i++)
        {
            overal[i]=0;
        }

        for(int i=0;i<N;i++)
        {
            int icnt;
            cin>>icnt;
            result+=icnt;

            int icetp;
            cin>>icetp;
            overal[icetp-1]++;
            stanky[i].insert(pair<int,int>(icetp,1));

            for(int j=1;j<icnt;j++)
            {
                cin>>icetp;
                overal[icetp-1]++;

                map<int,int>::iterator it = stanky[i].find(icetp);
                if(it!=stanky[i].end())
                {
                    //tam uz je
                    it->second++;
                }
                else
                {
                    stanky[i].insert(pair<int,int>(icetp,1));
                }
            }
        }

        //cout<<"stanky nacteny"<<endl;

        //Kontrola jestli ma reseni
        bool maReseni = true;
        for(int i=0;i<K;i++)
        {
            if(overal[i]==0)
            {
                maReseni=false;
                break;
            }
        }
        if(maReseni==false)
        {
            delete [] overal;
            delete [] stanky;
            cout<<-1<<endl;
            continue;
        }


        int curStanku=N;

        int lastStanek=N; //EXCLUDED
        int firstStanek=0;


        bestResult=result;
        //cout<<"Uvodni odpojeni"<<endl;

        while(true)
        {

            if(muzesOdpojit((stanky[firstStanek]),overal)==true)
            {
		//cout<<"uvodni odpojeni stanku "<<firstStanek<<endl;
                odpoj(stanky[firstStanek],overal);
                curStanku--;
                firstStanek++;
            }
            else
            {
                break;
            }
        }

        //cout<<"odpojeni ok"<<endl;
        //Prujezd
        for(;lastStanek<N*2;)
        {
            /*if(curStanku==N)
            {
                firstStanek++;
                continue;
            }*/

            bestResult=min(bestResult,result);

            //Pridani novehoStanku
            //cout<<"pridavam stanek: "<<lastStanek%N<<endl;

            pridej(stanky[lastStanek%N],overal);
            curStanku++;
            lastStanek++;

            //Zkus odebrat
            while(true)
            {
                if(muzesOdpojit(stanky[firstStanek%N],overal)==true)
                {
		//cout<<"odpojuju stanek: "<<firstStanek%N<<endl;
                    odpoj(stanky[firstStanek%N],overal);
                    curStanku--;
                    firstStanek++;

                }
                else
                {
                    break;
                }
            }

            bestResult=min(bestResult,result);

        }

        cout<<bestResult<<endl;

        delete [] overal;
        delete [] stanky;



    }
    return 0;
}

