#include <iostream>
#include <map>

using namespace std;


int main()
{
    ios::sync_with_stdio(false);

    int n, k;
    cin >> n >> k;

    int * flow = new int[n];
    double * bonus = new int[n];
    double * res = new double[n];
    multimap<double,int> cap;
    for (int i = 0; i < n; ++i) {
        flow[i] = k;
        bonus[i] = 0;
        int x;
        cin >> x;
        cap.insert(make_pair((double)x,i));
    }

    double global = 0;

    while ( !cap.empty()) {
        int low = cap.begin()->second;
        double lowest = cap.begin()->first;
        res[low] = (lowest-global-bonus[low])/(double)flow[low];
        global += k * res[low];
        if ( low+1 < n) {
            if ( flow[low+1]) flow[low+1] += flow[low];
            multimap<double,int>::iterator del = cap.end();
            for ( multimap<double,int>::iterator i = cap.begin(); i!= cap.end(); ++i) {
                if ( i->second == low+1 ) {

                del = i;
                }
            }
            if (del!= cap.end()) cap.erase(del);
            cap.insert(make_pair((double)x,i));
        }
        flow[low] = 0;
    }
    return 0;
}
