#include <iostream>
#include <iomanip>
#include <map>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    while(true)
    {
        long long N;
        cin>>N;
        if(cin.good()==false)
        {
            return 0;
        }

        map<int,int> NEdiags;
        map<int,int> NWdiags;

        for(int i=0;i<N;i++)
        {
            int X,Y;
            cin>>X>>Y;

            int NEdiag = Y-X;
            int NWdiag = X+Y;

            map<int,int>::iterator ne = NEdiags.find(NEdiag);
            if(ne!=NEdiags.end())
            {
                //existuje
                ne->second++;
            }
            else
            {
                NEdiags.insert(pair<int,int>(NEdiag,1));
            }

            map<int,int>::iterator nw = NWdiags.find(NWdiag);
            if(nw!=NWdiags.end())
            {
                //existuje
                nw->second++;
            }
            else
            {
                NWdiags.insert(pair<int,int>(NWdiag,1));
            }
        }

        long long resultativePicks=0;
        for(map<int,int>::iterator ne = NEdiags.begin();ne!=NEdiags.end();++ne)
        {
            resultativePicks+=((long long)ne->second)*((long long)ne->second);
        }
        for(map<int,int>::iterator nw = NWdiags.begin();nw!=NWdiags.end();++nw)
        {
            resultativePicks+=((long long)nw->second)*((long long)nw->second);
        }

        long long celkem = N*N;
        resultativePicks-=N+N;
        //cout<<"ResPicks: "<<resultativePicks<<" celkem: "<<celkem<<endl;
        double result = (double)resultativePicks/(double)celkem;
        cout<<fixed<<setprecision(10)<<result<<endl;






    }
    return 0;
}
